//   Controller DCCpp commande le logiciel DCC++ BASE STATION de Gregg E. Berman COPYRIGHT (c) 2013-2016 et DCCppS88

//   (©) 2016-2017 - Christophe BOBILLE
//   (©) 2019-2022 - Philippe Chavatte (lormedy.free.fr)
//
//   Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
//   au titre des clauses de la Licence Publique Générale GNU, telle que publiée
//   par la Free Software Foundation ; soit la version 3 de la Licence,
//   ou (à votre discrétion) une version ultérieure quelconque.

//   Ce programme est distribué dans l'espoir qu'il sera utile,
//   mais SANS AUCUNE GARANTIE ; sans même une garantie implicite de
//   COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE.
//   Voir la Licence Publique Générale GNU pour plus de détails.
//   Vous devriez avoir reçu un exemplaire de la Licence Publique Générale
//   GNU avec ce programme ; si ce n'est pas le cas, voyez http://www.gnu.org/licenses

//   This program is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.

//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with this program.  If not, see http://www.gnu.org/licenses
//   GNU General Public License:  http://opensource.org/licenses/GPL-3.0

//** Controller DCC++
//** v 2.2           - le 06/09/2016 à 19:03:00
//** v 2.3           - le 27/12/2016 à 09:38:00
//** v 2.4 (release) - le 29/01/2017 à 01:23:00
//** v 2.5 (release) - le 29/01/2017 à 09:15:00
//** v 2.6 (release) - le 29/01/2017 à 13:56:00
//           1° - Ajout d'une fenêtre de confirmation pour annuler la lecture de CV's en cas de problème.
//           Message reçu de DCC++ Base Station de type "<r123|123|1 -1>" avec -1 en fin.
//           2° - Arret de la loco si tentative de modifier la CV 1 (adresse) sur la voie principale alors
//           que la vitesse est > 0.
//** v 2.7 (release) - le 30/01/2017 à 12:29:00
//           1° - Ajout de fonctionnalités concernant la gestion des CV's comme l'ajout automatique des noms et labels
//           2° - Ajout du n° de version en haut de page
//           3° - Ajout d'une zone rétractable de paramètrage en haut de page
//           4° - Ajout d'options dans cette zone
//               * Selection de l'adresse IP de l'Arduino supportant DCC++ Base Station par menu déroulant.
//               * Choix du nombre de CV's à lire par menu déroulant.
//               * Ajout de plusieurs fonctions liées aux sauvegardes
//           5° La zone "Noms pour les fonctions :" dans les paramètrages de foncions à été rendue rétractable
//** v 2.8 (release) - le 02/02/2017 à 19:52:00
//           Ajout de "dccpp" dans les URL's des requêtes destinées à DCC++ Base Station pour être compatible
//** v 2.8.1 (release) - le 04/02/2017 à 21:23:00
//           Ajout d'un objet manufacturers contenant les informations relatives au fabricants de décodeurs
//           Ajout d'un objet cvLabels contenant les informations relatives aux labels des CV's
//           ********  ATTENTION ******** Le fichier "data.json" a été renommé "locos.json"
//           et se touve maintenant placés dans le répertoire "config".
//** v 2.8.2 à 2.8.5 (release) - le 21/02/2017 à 08:47:00
//           Nombreuses évolutions liées à la lecture des cv's et à leur programmation
//** v 3.0 R1 BETA - le 22/02/2017 à 18:21:00 Version on-line démo
//** v 3.0.1 R1 BETA - le 02/11/2017 à 10:02:00 Version desktop et serveur full
//** v 4.0 R5 BETA (Version pour Node.js) - le 07/11/2017 à 08:10:00
//
//   Cette version permet de communiquer par TCP avec DCC++ via un serveur Node.js
//   Elle permet de piloter la carte Arduino (DCC++ BaseStation) via le port série ou ethernet.
//   Dans le première cas, les fonctions de lecture de CV's ne sont pas disponibles.
//   Configuration requise :
//   -  NodeJs : dccpp_node.js
//   -  Liaison série USB : Arduino Uno ou Mega
//   -  Liaison ethernet : Arduino Mega + shield ethernet
//   -  DCC++ BaseStation version originale DCCpp_Uno : https://github.com/DccPlusPlus/BaseStation
//   -  Arduino Motor Shield ou Pololu Dual MC33926 Motor Shield
//
//   Documentation DCC++ : https://github.com/DccPlusPlus/BaseStation/wiki/Getting-Started-With-DCC---Hardware
//
//** v 4.1 (release) (Version pour Node.js) - le 22/11/2017 à 17:31:00
//           Correction de bugs
//           Ajout du Full Screen
//           Version sm pour tablettes et smartphones
//           Sauvegarde de paramétres sur disque via Node.js
//
//** v 4.2 (release) (Version pour Node.js) - le 27/11/2017 à 19:32:00
//           Correction de bugs sur serialPort
//           Améliorations sur la version smartphone
//           Affichage d'informations supplémentaires dans le terminal
//
//** v 5.0 (release) (Version pour WiFi) - le 31/08/2018 à 18:08:00
//
//** v 6.01 (release) (Version BRONZE pour WiFi) - le 23/08/2019 à 19:00:00 par Philippe Chavatte (lormedy.free.fr)
//         *** ce logiciel fonctionne avec une Base Station DCC++, DCCpp ou DCCppS88 sur Arduino MEGA serie dont le code n'est pas modifié, seul le code de l'ESP8266 est ajouté ***
//         Affichage d'information optionnel sur LCD 4x20 caractères connecté en I2C sur ESP8266 et ajout d'un bouton d'arret d'urgence
//         (Adaptation du cablage initial entre Arduino MEGA et ESP8266 avec le code ESP8266 correspondant pour la version D1/R2_mini)
//         Broadcast des données de l'Arduino MEGA vers le tableau de bord HTML de tous les clients
//         Amélioration et modification du code JavaScript
//         Verrouillage anti-défilement de l'onglet supérieur
//         Bouton "Coupez courant" général avec changement de couleur de l'onglet supérieur
//         Lecture du courant sur voie principale
//         Moniteur DCC pour suivre les échanges de données avec Arduino MEGA et ESP8266
//         Affichage de la config et du status de l'Arduino MEGA dans le Moniteur
//         Tableau de lecture de la retro-signalisation compatible S88 avec DCCpp_S88
//         Tableau de commandes DCC des aiguillages et des accessoires
//         Cadran de vitesse pour piloter les locomotives avec la vitesse maxi
//         Gestion de l'adresse des Unités Mutiples (CV19)
//         Réorganisation de la lecture et écriture des CV
//         Compatible tablette et PC avec écran Full-HD
//
//** v 6.1 (release) (Version pour WiFi) - le 23/12/2019 à 09:00:00 par Philippe Chavatte (lormedy.free.fr)
//         Ajout d'un bouton d'offset 0/512 dans l'onglet Aiguillages pour compatibilité avec d'autres logiciels
//         Affichage multicast de la vitesse/direction des locos de tous les clients
//
//** v 6.2 (release) (Version pour WiFi) - le 31/01/2020 à 19:00:00 par Philippe Chavatte (lormedy.free.fr)
//         Amélioration de la lecture groupée des CV
//
//** v 6.3 (release) (Version pour WiFi) - le 10/05/2020 à 21:00:00 par Philippe Chavatte (lormedy.free.fr)
//         Amélioration de la lecture des CV
//         Ajout des boutons pour lire la config du MEGA, son statut et effacer le Moniteur
//         Ajout du bouton Connexion/s WiFi
//         Ajout du bouton DMC pour lancer DCC Mobile Controller dans une fenêtre secondaire
//         Compatilité avec le logiciel DCC Mobile Controller
//
//** v 6.3.1 - le 25/11/2020 à 16:00:00 par Philippe Chavatte (lormedy.free.fr)
//         Affichage du courant Ext. à coté de Main
//         Ajout de la commande Accessoire Etendu pour commander les signaux
//
//** v 6.3.2 - le 20/01/2022 à 15:00:00 par Philippe Chavatte (lormedy.free.fr)
//         Ajout de la commande pour enregistrer le fichier des locos dans la zone de téléchargement du navigateur (Mathieu A.)
//         Amélioration de la gestion des fichiers
//
//** v 6.3.3 - le 15/06/2022 à 14:00:00 par Philippe Chavatte (lormedy.free.fr)
//         Simplification de l'affichage des courants avec la réponse <a1 2>. <z...> est suprimée dans DCCppS88
//
//*******************************************************************************************************************************

var trainsApp = angular.module('trainsApp', []);
trainsApp.controller('pilotLocosCtrl', function ($scope, $http, $timeout, $q) {


    //*******************************************************************************************//
    //*********** Déclaration et initialisation de variables globales et parametrages ***********//
    //*******************************************************************************************//


    // Num version
    $scope.numVersion = "6.3.3";
    // Url du serveur
    var ip = "192.168.0.15";
    // Port Websocket
    $scope.portWS = 81;
    var urlFlash = "./";
    IPWS = document.getElementById("IPWS");
    if (window.location.hostname != '') {
        // Url du serveur intégré dans la centrale DCC en WiFi
        ip = window.location.hostname;
        IPWS.value = ip;
        console.log('target = ws://' + ip + ':' + $scope.portWS);
        // $scope.socket = new WebSocket('ws://'+location.hostname+ ':' + $scope.portWS, ['arduino']);
    } else {
        ip = IPWS.value;
        urlFlash = ip + "/";
        console.log('myIP ' + ip + ':' + $scope.portWS);
        // $scope.socket = new WebSocket('ws://' + ip + ':' + $scope.portWS, ['arduino']);
    }
    // Création de l'objet locomotives qui est vide pour l'instant
    $scope.locomotives = null;
    // Création de l'objet locoSelectionnee qui est vide pour l'instant
    $scope.locoSelectionnee = 0;
    // Création de l'objet manufacturers qui est vide pour l'instant
    $scope.manufacturers = null;
    $scope.ManufacturersParam = null;
    // Création de l'objet cvLabels qui est vide pour l'instant
    $scope.cvLabels = null;
    // Création de l'objet param qui est vide pour l'instant
    $scope.param = null;
    // Valeurs par défaut de l'adresse (cv 1)
    $scope.numNewAdress = 3;
    // Valeurs par défaut de l'adresse (cv 19)
    $scope.numCv19 = 19;
    // Initialisation de la variable keyOfLastId (dernière Id attribuée )
    $scope.keyOfLastId = 0;
    // Etat de l'alimentation du réseau
    $scope.powerStatus = false;
    // Nombre de crans de traction
    $scope.maxStep = 126;
    // Vitesse maximum du cadran
    $scope.maxSpeed = 160;
    // Numéro de CV
    $scope.cvOtherParam = 0;
    // Deglitch speedgauge
    $scope.gaugeBusy = false;
    // Adresse DCC des accessoires
    $scope.DccAdd = 0;
    $scope.adirectd = document.getElementById("adirectd");   // pour WDD6
    $scope.adirectg = document.getElementById("adirectg");
    $scope.adroite = document.getElementById("adroite");
    $scope.agauche = document.getElementById("agauche");

    // Initialisation des fenêtres
    $scope.showSettings = false;
    $scope.showConsole = false;
    $scope.showLocomotives = true;
    $scope.showLocosIcons = true;
    $scope.showLocosListe = false;
    $scope.showLocoSelectionnee = false;
    $scope.showParametrages = false;

    const mainBar = document.getElementById('mainBar');
    var isConnected = false;
    var lastCommand = "";
    var lastCv= 128;        // le nombre de CV est limité ici à 128 mais peut etre modifié pour 512

    // ***************************** Paramètres par défaut **************************************//

    // Path des fichiers de config et user
    $scope.tab_pathConfigFiles = ['user/locos.json',
                                  'config/manufacturers.json',
                                  'config/cvLabels.json',
                                  'config/param.json'
                                 ];


    //*******************************************************************************************//
    //******************** Ouverture d'une fenetre avec DCC Mobile Controler ********************//
    //*******************************************************************************************//


    var windowObjectReference;
    var strWindowFeatures = "menubar=false,toolbar=false,location=yes,resizable=yes,scrollbars=yes,status=yes, width=540,height=960";

    openDMC = function () {
        windowObjectReference = window.open("./dmc.html", "DCC Mobile Controler", strWindowFeatures);
    }

    closeDMC = function () {
        windowObjectReference.close()
    }


    //*******************************************************************************************//
    //************************************** Ecouteurs ******************************************//
    //*******************************************************************************************//

    document.getElementById('btn_fullScreen').addEventListener('click', function() {
        $scope.$apply(function() {
            var el = document.documentElement,
              rfs = el.requestFullscreen
                || el.webkitRequestFullScreen
                || el.mozRequestFullScreen
                || el.msRequestFullscreen
            ;
            rfs.call(el);
        });
    });

    document.getElementById('btn_eStop').addEventListener('click', function() {
        document.getElementById('speedSlider').value = 0;
        $scope.$apply(function() {
            $scope.eStop();
        });
    });

    document.getElementById('btn_power').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.power();                      // toggle DCC power
        });
    });

    IPWS.addEventListener('change', function() {
        ip = document.getElementById('IPWS').value;
        $scope.$apply(function() {
            $scope.connect();
        });
    });

    goConnect = function () {
        if (event.keyCode == 13) {
            ip = document.getElementById('IPWS').value;
            $scope.connect();                    // connect to WiFi station
        }
    }

    // document.getElementById('WiFiConnect').addEventListener('click', function() {
        // ip = document.getElementById('IPWS').value;
        // $scope.$apply(function() {
            // toggleCheck();                       // connect/disconnect from WiFi station
        // });
    // });

    document.getElementById('btn_localStorageActive').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.param.localStorageActive = !$scope.param.localStorageActive;
        });
    });

   document.getElementById('addLoco').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.addLoco();
        });
    });

    document.getElementById('input_cvVolSon').addEventListener('change', function() {
        $scope.$apply(function() {
            var cv = $scope.locoSelectionnee.cvVolSon;
            if(cv != undefined && cv > 46) {
                function trouveCv(objLoco) {
                    return objLoco.key == $scope.locoSelectionnee.cvVolSon;
                }
                var obj = null;
                obj = $scope.locoSelectionnee.cv.find(trouveCv);

                if(obj === undefined) {
                    if(confirm("La CV "+cv+" n'existe pas, voulez-vous la créer ?")) {
                        let end = $scope.locomotives.length
                        for (let i = 0; i < end; i++) {
                            //let test = $scope.locomotives[i].id;
                            //if(test == $scope.locoSelectionnee.id) {
                            if($scope.locomotives[i].id == $scope.locoSelectionnee.id) {
                                $scope.createCv(i, cv, cv);
                                i = end;
                                $scope.locoSelectionnee.volumeSon = 0;
                            }
                        }
                    }
                }
                if($scope.locoSelectionnee.cv[cv]["label"] == "")
                    $scope.locoSelectionnee.cv[cv]["label"] ="Volume son général";
            }
            else
                alert("Valeur de CV invalide.");
        });
    });

    document.getElementById('slider_volumeSon').addEventListener('change', function() {
        $scope.$apply(function() {
            $scope.setVolumeSon();
        });
    });

    document.getElementById('btn_readCV1').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.getOtherParam(1);
        });
    })

    document.getElementById('btn_readCV19').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.getOtherParam(19);
        });
    });

    document.getElementById('btn_readCV17_18').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.readCV17_18();
        });
    });

    document.getElementById('input_newLongAddress').addEventListener('change', function() {
        $scope.$apply(function() {
            $scope.newLongAddress();
        });
    });

    for (let i = 0; i < 8; i++) {
        document.getElementById('cv29bit'+i).addEventListener('change', function() {
            $scope.$apply(function() {
                $scope.setCv29();
            });
        });
    }

    document.getElementById('btn_readCv').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.readCv($scope.scanCvStart, $scope.scanCvEnd);
        });
    });

    document.getElementById('btn_getOtherParam').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.getOtherParam($scope.cvOtherParam);
        });
    });

    document.getElementById('btn_setOtherParam').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.setOtherParam($scope.cvOtherParam, $scope.labelOtherParam, $scope.valueOtherParam);
        });
    });
/*
    document.getElementById('s88Byte').addEventListener('change', function() {
        $scope.$apply(function() {
            $scope.setS88Byte();
        });
    });
*/
    setNbreAig = function () {
    // document.getElementById('nbreAiguillages').addEventListener('change', function() {
        if (event.keyCode == 13) {
            $scope.$apply(function() {
                $scope.drawAccPanel();
            });
        }
    }
    // });

    xAdresseVal_Enter = function (xA, xA_Value) {
        if (event.keyCode == 13) {
            $scope.sendXAdresseVal(xA, xA_Value);
        }
    }

    document.getElementById('btn_readCurrent').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.setParamDCC('c');             // display drawn current
        });
    });

    document.getElementById('btn_readCurrent2').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.setParamDCC('c');             // display drawn current
        });
    });

    document.getElementById('signal').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.setParamDCC('0');   // Power off
        });
    });

    document.getElementById('btn_DisplayConfig').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.setParamDCC('C');             // display Mega config
        });
    });

    document.getElementById('btn_DisplayStatus').addEventListener('click', function() {
        $scope.$apply(function() {
            $scope.setParamDCC('s');             // display DCCpp Status
        });
    });

    document.getElementById('btn_ClearMon').addEventListener('click', function () {
        document.getElementById('monitor').innerHTML = "";     // Clear Monitor display
    });

    document.getElementById('LocoAddress').addEventListener('change', function() {
        $scope.locoSelectionnee.address = parseInt(document.getElementById('LocoAddress').value);
    });


    //*******************************************************************************************//
    //*************************** Selection locos et affichage locos ****************************//
    //*******************************************************************************************//


    // La méthode "selectionLoco" affecte à l'objet "locoSelectionnee" les informations de la locomotive sélectionnée
    $scope.selectionLoco = function (loco) {
        $scope.locoSelectionnee = loco;
        $scope.showLocoSelectionnee = true;
        $scope.showParametrages = true;
        $scope.numNewAdress = $scope.locoSelectionnee.cv[1].value;
        $scope.numCv19 = $scope.locoSelectionnee.cv[19].value;
        $("#speedSlider").slider("value", $scope.locoSelectionnee.vitesse);
    }

    // La méthode showLocos permet de choisir le mode d'affichage des locos
    $scope.showLocos = function(origin) {
        if(origin == "icons") {
            if($scope.showLocosListe) {
                $scope.showLocosIcons = true;
                $scope.showLocosListe = false;
            }
        }
        else {
            if($scope.showLocosIcons) {
                $scope.showLocosIcons = false;
                $scope.showLocosListe = true;
            }
        }
    }


    //*******************************************************************************************//
    //**************************** Création et suppression de locos *****************************//
    //*******************************************************************************************//


    // Création d'une nouvelle loco
    $scope.nouvelleLoco = null;
    $scope.addLoco = function(x) {
        return $q(function() {
            if(x == undefined)
                x = 3;
            $scope.keyOfLastId++;
            var newId = $scope.keyOfLastId;
            $scope.nouvelleLoco = {
                id: newId,
                address: x,
                nomCourt: "Nouvelle loco",
                nomLong: "",
                urlImg: "",
                vitesse:0,
                cvVolSon:0,
                volumeSon:0,
                cv29bit:[],
                cv29bit5:0,
                newCV17val:0,
                newCV18val:0,
                newLongAddressVal:0,
                numCv19:0,
                sens:1,
                fn:[],
                btn_fn:[],
                btn_fn_label:["","","","","","","","","","","","","","","","","","","","","","","","","","","","",""],
                "fn0to4": 0,
                "fn5to8": 0,
                "fn9to12": 0,
                "fn13to20": 0,
                "fn21to28": 0,
                cv:[
                     {"key":0,"name":"","label":"","value": 0,"valHex":"","valBin":""},
                     {"key":1,"name":"Adresse","label":"Adresse","value": x, "valHex":"", "valBin":""}
//-                    {"key":0,"label":"Vitesse maxi","value": 0},
//-                    {"key":1,"label":"Adresse","value": x}
                ]
            }
            $scope.locomotives.push($scope.nouvelleLoco);
            $scope.createCv($scope.locomotives.length-1, 0, lastCv);                 // modif 511
///            $scope.showLocosIcons = false;
///            $scope.showLocosListe = true;
        });
    }

    // Supprimer une loco
    $scope.deleteLoco = function(obj, loco) {
        $scope.selectionLoco(obj);
        if(confirm("Voulez-vous supprimer la loco : \"" + loco +"\" ?")) {
                $scope.locomotives.splice($scope.locomotives.indexOf(obj), 1);
                $scope.locoSelectionnee = null;
        }
    }


    //*******************************************************************************************//
    //******************************** Pilotage des locos ***************************************//
    //*******************************************************************************************//


    // Envoi de la commande vers DCC
    $scope.setParamDCC = function(data) {
        data = "<" + data + ">";
        console.log("setParamDCC " + data);
        $scope.sendReq(data); //... et on appele la fonction qui va envoyer l'information à DCCpp
    }

    // Fonctions traction
    $scope.setTraction = function() {
        if ($scope.powerStatus === false) {
            $scope.responseServer = "L'alimentation DCC est coupée !";
            return;
        }

        // var data = `t $scope.locoSelectionnee.id $scope.locoSelectionnee.address $scope.locoSelectionnee.vitesse $scope.locoSelectionnee.sens`;
        if ($scope.locoSelectionnee.address > 3) {
            var data = "t ";
            data += $scope.locoSelectionnee.id;
            data += " ";
            data += $scope.locoSelectionnee.address;
            data += " ";
            data += $scope.locoSelectionnee.vitesse;
            data += " ";
            data += $scope.locoSelectionnee.sens;
            $scope.setParamDCC(data);
            $scope.gaugeBusy = false;
            // console.log("setTraction " + data);
            lastCommand = data;
        }
    }

    // Bouton arret
    $scope.stopLoco = function () {
        $scope.locoSelectionnee.vitesse = 0;
        $("#speedSlider").slider("value", 0);
        // $("#throttleSpeedGauge").focus();
    }

    // Bouton marche AV
    $scope.goAv = function () {
        if($scope.locoSelectionnee.sens == 0) {
            $scope.locoSelectionnee.sens = 1;
            $scope.stopLoco();
            $("#LocoAddress").focus();
        }
    }

    // Bouton marche AR
    $scope.goAr = function () {
        if($scope.locoSelectionnee.sens == 1) {
            $scope.locoSelectionnee.sens = 0;
            $scope.stopLoco();
            $("#LocoAddress").focus();
        }
    }


    //*******************************************************************************************//
    //*************************************** e-Stop ********************************************//
    //*******************************************************************************************//


    // Arret immediat de la locomotive
    $scope.eStop = function() {
        $("#speedSlider").slider("value", 0);
///        document.getElementById('speedSlider').value = 0;
        if($scope.locoSelectionnee != null) {
            $scope.locoSelectionnee.vitesse = -1;
            $scope.setTraction();
        }
    }

    //*******************************************************************************************//
    //*********************** Capture du pointeur sur le cadran & slider ************************//
    //*******************************************************************************************//


    function onClickCanvas(e) {
        if ($scope.powerStatus === false) {
            $scope.responseServer = "L'alimentation DCC est coupée !"
            return;
        }

        if ($scope.gaugeBusy == true) return;

        $scope.gaugeBusy = true;
        let scale = 450;
        let center = { x: scale / 2, y: scale / 2 };
        let CenterX = center.x;
        let CenterY = center.y;

        e.preventDefault();

        let rect = e.target.getBoundingClientRect();
        let x = e.clientX - rect.left;
        let y = e.clientY - rect.top;
        let rx = x - CenterX;
        let ry = y - CenterY;
        calcPos(rx, ry);
    }

    function calcPos(rx, ry) {
        let aR = Math.sqrt(rx * rx + ry * ry);
        if ((aR < 30) || (aR > 220)) {
            // Ignorer l'intérieur et l'extérieur du cercle */
            return;
        }

        let aTheta = Math.atan2(ry, rx) + Math.PI;
        let aTheta_r = (aTheta * 180 / Math.PI);

        // Ignorer le triangle équilateral ayant pour base l'image
        // 240deg - 290deg n'est pas une plage valide
        if ((aTheta_r < 290) && (aTheta_r > 240)) {
            return;
        }

        // Réglage de la tolérance 0 speed
        if ((aTheta_r <= 320) && (aTheta_r >= 270)) {
            aTheta_r = 315;
        }

        // Réglage de la tolérance max speed
        if ((aTheta_r >= 220) && (aTheta_r <= 240)) {
            aTheta_r = 225;
        }

        // Normalisation
        if (aTheta_r > 300) {
            aTheta_r = aTheta_r - 360 + 45;
        }
        else {
            aTheta_r = aTheta_r + 45;
        }

        // console.log("rx "+ rx, "   ry " + ry + "   aTheta_r " + aTheta_r + "   " + $scope.gaugeBusy);
        // Conversion de l'angle à la valeur de la vitesse
        // en supprimant délibérément la précision pour réduire le poids du traitement 32b/64b
        let LocSpeedStep = Math.round((aTheta_r) * $scope.maxStep / 270);
        $scope.locoSelectionnee.vitesse = LocSpeedStep;
        $("#speedSlider").slider("value", LocSpeedStep);
        // $scope.setTraction(); // exécuté ci-dessous
    }

    $(function () {
        $("#speedSlider").slider({
            animate: "fast",
            min: 0,
            max: $scope.maxStep,
            range: false,
            step: 1,  // default: 1
            value: 0, // default: 0
            orientation: 'horizontal',
            change: function (event, ui) {
                if (($scope.powerStatus == true) || ($scope.locoSelectionnee.vitesse == 0)) {
                    $scope.locoSelectionnee.vitesse = ui.value;
                    $scope.setTraction();
                }
            },
            slide: function (event, ui) {
                if (($scope.powerStatus == true) || ($scope.locoSelectionnee.vitesse == 0)) {
                    $scope.locoSelectionnee.vitesse = ui.value;
                    $scope.setTraction();
                }
            }
        });

        $("#speedSlider").css('background', '#00C0FF');   // fond de la piste
        $("#speedSlider").css('border-color', '#FF2929'); // contour de la piste

        $("input[type=submit], a, button")
            .button()
            .click(function (event) {
                event.preventDefault();
            });
    });


    //*******************************************************************************************//
    //************************ Activation ou désactivation des fonctions ************************//
    //*******************************************************************************************//


    $scope.setFn = function (n) { // OPERATE ENGINE DECODER FUNCTIONS F0-F28
        if ($scope.powerStatus === false) {
            $scope.responseServer = "L'alimentation DCC est coupée !"
            return;
        }

        var res = 0;
        var data = "f"; // <f CAB BYTE1 [BYTE2]>
        data += " ";
        data += $scope.locoSelectionnee.address;
        data += " ";

        for( let i = 0; i < arguments.length; i++) {
            $scope.locoSelectionnee.fn[arguments[i]] = $scope.locoSelectionnee.btn_fn[arguments[i]] ? Math.pow(2, i) : 0;
            res += $scope.locoSelectionnee.fn[arguments[i]];
        }
        switch (n) {
            case 0:
                data += 128 + res;
                break;
            case 5:
                data += 176 + res;
                break;
            case 9:
                data += 160 + res;
                break;
            case 13:
                data += 222;
                data += " ";
                data += res;
                break;
            case 21:
                data += 223;
                data += " ";
                data += res;
                break;
        }
        $scope.setParamDCC(data);
        console.log("setFn " + data);
    }


    //*******************************************************************************************//
    //********************************* Lecture des CV's ****************************************//
    //*******************************************************************************************//

    var cv1 = 0;
    var CVTimeout = 2000;    // temps de lecture d'un CV

    $scope.parseCv = function (response) {
        let temp = response.substring(10);
        temp = temp.substr(0, temp.length - 1);
        let spaceIndex = temp.indexOf(" ");
        var cvNr = Number.parseInt (temp.substring(0, spaceIndex), 10);
        let cvData = Number.parseInt (temp.substring(spaceIndex+1), 10);
        let longAddress = 0;

        if(cvData < 0) { // La valeur renvoyée est négative, problème de lecture
            $scope.afficheReponse("Erreur de lecture CV " + cvNr + " !");
            return;
        }
        else {
            if (cvNr === 1) {
                cv1 = cvData;
                $scope.labelOtherParam = "Adresse courte";
                $scope.locoSelectionnee.cv[1].value = cvData;
                document.getElementById("CV1").value = cvData;
                if (response.indexOf("<r456|456|") == 0)
                    document.getElementById('LocoAddress').value = cvData;
            }

            function trouveCv(objLoco) {
                return objLoco.cv[1].value == cv1;
            }
            // Création d'un objet vide
            var obj = null;
            // Chercher dans obj locomotives si la CV existe
            obj = $scope.locomotives.find(trouveCv);
            if(obj === undefined || obj === null) {
                var promise = $scope.addLoco(cv1); // Création de la loco
                obj = $scope.locomotives.find(trouveCv);
            }

            obj.cv[cvNr].value = cvData;
            obj.cv[cvNr].valHex = $scope.convertHex(cvData);
            obj.cv[cvNr].valBin = $scope.convertBin(cvData);

            console.log("cv1: " + cv1 + "    ID: " + $scope.locoSelectionnee.id + "     cvNr: " + cvNr + "    obj.cv[cvNr]: " +  obj.cv[cvNr].value);

            document.getElementById("readCV").value = cvData;
            $scope.valueOtherParam = cvData;
            $scope.locoSelectionnee.cv[cvNr]['value'] = cvData;
            $scope.locoSelectionnee.cv[cvNr]['valHex'] = $scope.convertHex(cvData);
            $scope.locoSelectionnee.cv[cvNr]['valBin'] = $scope.convertBin(cvData);

            if( (obj.cv[cvNr]["label"] == "") || (obj.cv[cvNr]["label"] == null) ) {
                if($scope.cvLabels[cvNr] != undefined) {
                    $scope.labelOtherParam = $scope.cvLabels[cvNr]["label"];
                    // console.log("if  obj.cv[cvNr]['label']:   " + obj.cv[cvNr]["label"]);
                }
                else {
                    $scope.labelOtherParam = "( Créez ce paramètre - Entrez un libellé et une valeur )";
                    console.log("else   " + obj.cv[cvNr]["label"]);
                }
            }
            else {
                $scope.labelOtherParam = obj.cv[cvNr]["label"];
            }

            switch(cvNr) {
                case 1:
                    $scope.labelOtherParam = "Adresse courte";
                    document.getElementById("CV1").value = cvData;
                    if (response.indexOf("<r456|456|") == 0)
                        document.getElementById('LocoAddress').value = cvData;
                break;
                case 8:
                    $scope.labelOtherParam = "Manufacturer ID : "+$scope.getManufacturers(cvData);
                    $scope.locoSelectionnee.cv[cvNr]["label"] = $scope.labelOtherParam;
                    obj.cv[cvNr]["label"] = $scope.labelOtherParam;
                break;
                case 17:
                    // obj.newCV17val = cvData;
                    $scope.labelOtherParam = "Adresse loco étendue";
                    document.getElementById("CV17").value = cvData;
                    $scope.locoSelectionnee.newCV17val = cvData;
                break;
                case 18:
                    // obj.newCV18val = cvData;
                    $scope.labelOtherParam = "Adresse loco étendue";
                    document.getElementById("CV18").value = cvData;
                    longAddress = ( (document.getElementById("CV17").value - 192) * 256) + cvData;
                    document.getElementById("input_newLongAddress").value = longAddress;
                    $scope.locoSelectionnee.newLongAddressVal = longAddress;
                    $scope.locoSelectionnee.newCV18val = cvData;
                    if (response.indexOf("<r456|456|") == 0)
                        document.getElementById('LocoAddress').value = longAddress;
                break;
                case 19:
                    $scope.labelOtherParam = "Adresse Multi-Traction";
                    document.getElementById("CV19").value = cvData;
                    if (response.indexOf("<r456|456|") == 0) {
                        document.getElementById('LocoAddress').value = cvData;
                    }
                    // obj.numCv19 = cvData;

                break;
                case 29:
                    if (response.indexOf("<r123|123|") == 0) {
                        $scope.labelOtherParam = "Registre de configuration";
                        for(let i = 0; i < 8; i++) {
                            if(obj.cv[cvNr].valBin.substring(i,i+1) == 1) {
                                obj.cv29bit[7-i] = true;
                                $scope.locoSelectionnee.cv29bit[7-i] = true;
                            }
                            else {
                                obj.cv29bit[7-i] = false;
                                $scope.locoSelectionnee.cv29bit[7-i] = false;
                            }
                        }

                        if(obj.cv29bit[5] == true) {
                            longAddress = ( ($scope.locoSelectionnee.cv[17].value - 192) * 256 ) + $scope.locoSelectionnee.cv[18].value;
                            document.getElementById('LocoAddress').value = longAddress;
                            $scope.locoSelectionnee.address = longAddress;
                        }
                        else {
                            document.getElementById('LocoAddress').value = obj.cv[1].value;
                            $scope.locoSelectionnee.address = obj.cv[1].value;
                        }
                    }
                break;
                case 63:
                    $scope.labelOtherParam = "Volume son général";
                    //document.getElementById("input_cvVolSon").value = cvNr;
                    document.getElementById("slider_volumeSon").value = cvData;
                    $scope.locoSelectionnee.volumeSon = cvData;
                    obj.cv[cvNr]["label"] = $scope.labelOtherParam;
                break;
            } // End of switch

            obj.cv[cvNr]["label"] = $scope.labelOtherParam;
            $scope.locoSelectionnee.cv[cvNr]["label"] = $scope.labelOtherParam;
            console.log("label2  " + $scope.labelOtherParam + "   obj label " + obj.cv[cvNr]["label"]);
        }
    }

    $scope.getOtherParam = function(cvNr) {  //read One CV
        if(cvNr > 0 && cvNr <= lastCv) {                                // modif 511
            if($scope.powerStatus === true) {
                $scope.param.cvPgmType = "prog";
                $scope.cvOtherParam = cvNr;
                document.getElementById('numCV').value = cvNr;
                // On lit le cv
                let data = "<R "+cvNr+" 123 123>";
                $scope.sendReq(data);
            }
            else
                $scope.afficheReponse("Alimentation DCC coupée !");
            //End if($scope.powerStatus === true)
        }
        else
            $scope.afficheReponse("CV mal renseignées !");
        // End if(start > 0 && end > 0)
    }

    $scope.readCV17_18 = function() {
        $scope.getOtherParam(17);
        $scope.getOtherParam(18);
    }

    $scope.readCv = function(start, end) {                 // lire un groupe de CV
        if(start > 0 && end >= start) {
            if($scope.powerStatus === true) {
                var readCVDelay = 0;
                if ( $scope.locoSelectionnee.cv[1].value < 4) {
                    $scope.getOtherParam(1);
                    setTimeout(function() { $scope.getOtherParam(17); }, CVTimeout);
                    setTimeout(function() { $scope.getOtherParam(18); }, CVTimeout*2);
                    setTimeout(function() { $scope.getOtherParam(29); }, CVTimeout*3);   // ne pas changer cet ordre
                    setTimeout(function() { $scope.getOtherParam(19); }, CVTimeout*4);
                    readCVDelay = CVTimeout*5;
                }

                if ((start == 1) && (readCVDelay != 0))    // La CV 1 a déjà été scannée
                    start = 2;

                for(let i = start; (i <= end) ; i++) {
                    setTimeout(function() {
                        $scope.getOtherParam(i);
                    }, CVTimeout*(i-start) + readCVDelay);
                }
            }
            else
                $scope.afficheReponse("Alimentation DCC coupée !");
            // End if($scope.powerStatus === true)
        }
        else
            $scope.afficheReponse("CV non renseignées !");
        // End if(start > 0 && end > 0)
    }

    // Recherche du constructeur du décodeur pour MAJ CV 8
    $scope.getManufacturers = function (x) {

        function searchManufacturer(manufacturerId) {
            return manufacturerId.id == x;
        }
        // création d'un objet vide
        let obj = null;
        // chercher dans obj si la key existe
        obj = $scope.manufacturers.find(searchManufacturer);
///        obj = ManufacturersParam.find(searchManufacturer);
        if(obj === undefined) return "unknown";
        else return obj.manufacturer;
    }

    $scope.createCv = function(x, start, end) {
        // Création des CVs qui n'existent pas pour chaque loco
        for( let i = start; i <= end; i++ ) {
            function trouveCv(objLoco) {
                return objLoco.key == i;
            }
            // Création d'un objet vide
            let obj = null;
            // Chercher dans obj locomotives si la CV existe
            obj = $scope.locomotives[x].cv.find(trouveCv);
            if(obj === undefined) {  // La CV n'existe pas
                var cvName = "";
                if (i>32 && i<47) {
                    if (i==33) cvName = "F0F";
                    else if (i==34) cvName = "F0R";
                        else cvName = "F"+toString(i-34);
                }
                $scope.newCv = {
                    key: i,
                    name: "cvName",
                    label: "",
                    value: 0,
                    valHex: "",
                    valBin: ""
                }
                $scope.locomotives[x].cv.push($scope.newCv);
            }  // if
        }
    }


    //*******************************************************************************************//
    //***************************** Modification des CV's ***************************************//
    //*******************************************************************************************//


    // Fonctions param CV's
    $scope.setCv = function(cv, value) {
        switch ($scope.param.cvPgmType) {
            case "main": // WRITE CONFIGURATION VARIABLE BYTE TO ENGINE DECODER ON MAIN OPERATIONS TRACK
            //<w CAB CV VALUE>
                // Mettre la loco à l'arrêt si ça n'est pas le cas pour réglage CV adresse
                if($scope.locoSelectionnee.vitesse > 0 &&  cv == 1)
                    $scope.locoSelectionnee.vitesse = -1;
                var data = "w";
                data += " ";
                data += $scope.locoSelectionnee.address;
                data += " ";
                data += cv;
                data += " ";
                data += value;
                break;
            case "prog": // WRITE CONFIGURATION VARIABLE BYTE TO ENGINE DECODER ON PROGRAMMING TRACK
            //<W CV VALUE CALLBACKNUM CALLBACKSUB>
                var data = "W";
                data += " ";
                data += cv;
                data += " ";
                data += value;
                data += " ";
                data += "456";
                data += " ";
                data += "456";
                break;
        }
        $scope.setParamDCC(data);
    }

        // Changement d'adresse
    $scope.setNewShortAdress = function() {
        $scope.setCv(1, $scope.numNewAdress);
        if ($scope.locoSelectionnee.cv[19].value == 0) {
            $scope.locoSelectionnee.address = $scope.numNewAdress;
            document.getElementById('LocoAddress').value = $scope.numNewAdress;
        }

        $scope.locoSelectionnee.cv[1]['value'] = $scope.numNewAdress;
        $scope.locoSelectionnee.cv[1]['valHex'] = $scope.convertHex($scope.numNewAdress);
        $scope.locoSelectionnee.cv[1]['valBin'] = $scope.convertBin($scope.numNewAdress);
        if ($scope.locoSelectionnee.cv[1].label == "")
            $scope.locoSelectionnee.cv[1].label = "Adresse courte";

        // Désactiver adresse longue dans CV 29
        $scope.locoSelectionnee.cv29bit[5] = false;
        $scope.setCv29();
    }

    $scope.setNewUmAddress = function() {
        $scope.setCv(19, $scope.locoSelectionnee.cv[19].value);
        $scope.locoSelectionnee.address = $scope.locoSelectionnee.cv[19].value;
        $scope.locoSelectionnee.cv[19]['value'] = $scope.locoSelectionnee.cv[19].value;
        $scope.locoSelectionnee.cv[19]['valHex'] = $scope.convertHex($scope.locoSelectionnee.cv[19].value);
        $scope.locoSelectionnee.cv[19]['valBin'] = $scope.convertBin($scope.locoSelectionnee.cv[19].value);
        if ($scope.locoSelectionnee.cv[19].label == "")
            $scope.locoSelectionnee.cv[19].label = "Adresse multi-traction (UM)";

        if ($scope.locoSelectionnee.cv[19].value == 0) {
            if ($scope.locoSelectionnee.cv29bit[5] == false) {
                $scope.locoSelectionnee.address = $scope.locoSelectionnee.cv[1]['value'];
            } else {
                let longAddress = ( ($scope.locoSelectionnee.cv[17].value - 192) * 256) + $scope.locoSelectionnee.cv[18].value;
                $scope.locoSelectionnee.address = longAddress;
            }
            document.getElementById('LocoAddress').value = $scope.locoSelectionnee.address;
        }
    }

    // Volume son
    $scope.setVolumeSon = function() {
        let cvNum = $scope.locoSelectionnee.cvVolSon;
        let value = $scope.locoSelectionnee.volumeSon;
        $scope.setCv(cvNum, value);
        $scope.locoSelectionnee.cv[cvNum]['value'] = value;
        $scope.locoSelectionnee.cv[cvNum]['valHex'] = $scope.convertHex(value);
        $scope.locoSelectionnee.cv[cvNum]['valBin'] = $scope.convertBin(value);
        if ($scope.locoSelectionnee.cv[cvNum]["label"] == "")
            $scope.locoSelectionnee.cv[cvNum]["label"] ="Volume son général";
    }

    // Envoi aux locos de toutes les autres modifications sur les cv
    $scope.setOtherParam = function(cv, newLabel, newValue) {
        $scope.param.cvPgmType = "prog";
        $scope.searchInfosCv(cv);
        if (cv == 19) return($scope.setNewUmAddress());
        $scope.setCv(cv, newValue);
        if (cv == 8 && newValue == 4) {                     // A voir, selon décodeur
            $scope.locoSelectionnee.cv[1].value = 3;
            $scope.locoSelectionnee.address = 3;
            $scope.locoSelectionnee.cv29bit[5] = false;
        }

        if (cv == $scope.locoSelectionnee.cvVolSon )
            $scope.locoSelectionnee.volumeSon = newValue;

        $scope.locoSelectionnee.cv[cv]["label"] = newLabel;
        $scope.locoSelectionnee.cv[cv]['value'] = newValue;
        $scope.locoSelectionnee.cv[cv]['valHex'] = $scope.convertHex(newValue);
        $scope.locoSelectionnee.cv[cv]['valBin'] = $scope.convertBin(newValue);
     }

    // methode de recherche pour "modif OtherParam"
    $scope.searchInfosCv = function (cvOtherParam) {

        function searchCv(element, index, array) {
            if (element.key == $scope.cvOtherParam)
                return "ok";
        }

        var indexOfCv = $scope.locoSelectionnee.cv.findIndex(searchCv);
        if ( indexOfCv > -1) {
            $scope.labelOtherParam = $scope.locoSelectionnee.cv[indexOfCv].label;
            if ($scope.labelOtherParam == "" )
                $scope.labelOtherParam = $scope.cvLabels[indexOfCv]["label"];
            $scope.valueOtherParam = Number($scope.locoSelectionnee.cv[indexOfCv].value);
        }
        else {
            $scope.labelOtherParam = "( Créez ce paramètre - Entrez un libellé et une valeur)";
            $scope.valueOtherParam = 0;
        }
    }

    // Long address
    $scope.newLongAddress = function () {
        let longAddress = Number($scope.locoSelectionnee.newLongAddressVal);
        let cv17 = Number($scope.locoSelectionnee.newCV17val);
        let cv18 = Number($scope.locoSelectionnee.newCV18val);

        let quotien = Math.floor(longAddress / 256);
        cv17 = Number(192 + quotien);
        cv18 = Number(longAddress % 256);

        $scope.locoSelectionnee.newCV17val = cv17;
        $scope.locoSelectionnee.newCV18val = cv18;
    }

    $scope.setNewLongAddress = function() {
        $scope.locoSelectionnee.cv[17]['value'] = $scope.locoSelectionnee.newCV17val;
        $scope.locoSelectionnee.cv[18]['value'] = $scope.locoSelectionnee.newCV18val;
        $scope.locoSelectionnee.cv[17]['valHex'] = $scope.convertHex($scope.locoSelectionnee.newCV17val);
        $scope.locoSelectionnee.cv[18]['valHex'] = $scope.convertHex($scope.locoSelectionnee.newCV18val);
        $scope.locoSelectionnee.cv[17]['valBin'] = $scope.convertBin($scope.locoSelectionnee.newCV17val);
        $scope.locoSelectionnee.cv[18]['valBin'] = $scope.convertBin($scope.locoSelectionnee.newCV18val);
        $scope.locoSelectionnee.cv29bit[5] = true;
        $scope.setCv(17, $scope.locoSelectionnee.newCV17val);
        $scope.setCv(18, $scope.locoSelectionnee.newCV18val);
        $scope.setCv29();
    }

    // CV 29
    $scope.setCv29 = function () {
        $scope.locoSelectionnee.cv[29]['value'] = 0;
        for (let i = 0; i < 8; i++)
            $scope.locoSelectionnee.cv[29]['value'] += $scope.locoSelectionnee.cv29bit[i] ? Math.pow(2, i) : 0;

        $scope.locoSelectionnee.cv[29]['valHex'] = $scope.convertHex($scope.locoSelectionnee.cv[29]['value']);
        $scope.locoSelectionnee.cv[29]['valBin'] = $scope.convertBin($scope.locoSelectionnee.cv[29]['value']);

        if ($scope.locoSelectionnee.cv[19].value == 0) {
            if ($scope.locoSelectionnee.cv29bit[5] && $scope.locoSelectionnee.newLongAddressVal != "")
                $scope.locoSelectionnee.address = $scope.locoSelectionnee.newLongAddressVal;
            else
                $scope.locoSelectionnee.address = $scope.locoSelectionnee.cv[1]['value'];
        }
        else {
            $scope.locoSelectionnee.address = $scope.locoSelectionnee.cv[19]['value'];
        }
        document.getElementById('LocoAddress').value = $scope.locoSelectionnee.address
        $scope.setCv(29, $scope.locoSelectionnee.cv[29]['value']);
    }

    // Conversion en Hexadécimal
    $scope.convertHex = function(val) {
        val = Number(val);
        let hex = val.toString(16);
        if (hex.length == 1) { hex = "0x0"+hex }
        else { hex = "0x"+hex }
        return hex;
    }

    // Conversion en Binaire
    $scope.convertBin = function(val) {
        val = Number(val);
        let bin = val.toString(2);
        for ( let i = bin.length; i < 8; i++)
            bin = "0" + bin;
        return bin;
    }


    //*******************************************************************************************//
    //****************************** Aiguillages et accessoires *********************************//
    //*******************************************************************************************//


    $scope.AccPageNo = 0;                  // Acc
    $scope.AccPanelWidth = 16;             // Acc, toggle 16/8 columns
    $scope.AccOffset = 0;                  // Acc, toggle 0/512 start
    $scope.AccStatus = new Array(512, 0);  // Acc

    $scope.drawAccPanel = function() {
        var canvas = document.getElementById("accCanvas");
        var cv = canvas.getContext("2d");

        $scope.nbreAiguillage = parseInt(document.getElementById("nbreAiguillages").value);
        if ($scope.nbreAiguillage < 0)   $scope.nbreAiguillage = 0;
        if ($scope.nbreAiguillage > 512) $scope.nbreAiguillage = 512;

        canvas.addEventListener("mousedown", $scope.onClickAccCanvas);
        canvas.addEventListener("touchstart", $scope.onClickAccCanvas);

        // Dessin des carrés
        var cvSizeH = canvas.getAttribute("width");
        var cvSizeV = canvas.getAttribute("height");
        cv.clearRect(0, 0, cvSizeH, cvSizeV);

        // Canvas Couleur de police
        cv.font = "16px 'arial'";

    // Affichage des aiguillages et des points (ronds)
        for (var y = 0; y < 4; y++) {
            for (var x = 0; x < $scope.AccPanelWidth; x++) {
                var xx = x * 112 + 16;
                if (x > 7) xx += 40;
                var yy = y * 100 + 1;
                var index = (y + $scope.AccPageNo * 4) * $scope.AccPanelWidth + x;

                cv.shadowBlur = 0;
                cv.fillStyle = '#EFEFEF';
                cv.strokeStyle = '#8F8F8F';
                cv.beginPath();
                cv.moveTo(xx, yy);
                cv.lineTo(xx + 80, yy);
                cv.lineTo(xx + 80, yy + 90);
                cv.lineTo(xx, yy + 90);
                cv.lineWidth = "1px";
                cv.lineCap = "round";
                cv.closePath();
                cv.fill();
                cv.stroke();
                // Spécification de dégradé
                /**/
                cv.shadowColor = '#9F9F9F';
                cv.shadowOffsetX = 4;
                cv.shadowOffsetY = 4;
                cv.shadowBlur = 8;

                    if (index < 512) {
                    cv.beginPath();
                    if (index < $scope.nbreAiguillage) {
                        switch ($scope.AccStatus[index]) {
                            case 0:
                                cv.drawImage($scope.adirectd, xx + 35, yy + 8);
                                break;
                            case 1:
                                cv.drawImage($scope.adroite, xx + 35, yy + 8);
                                break;
                            case 2:
                                cv.drawImage($scope.adirectg, xx + 35, yy + 8);
                                break;
                            case 3:
                                cv.drawImage($scope.agauche, xx + 35, yy + 8);
                                break;
                        }
                    }
                    else {                 // Affichage des points ronds
                        cv.arc(xx + 40, yy + 55, 25, 0, Math.PI * 2, false);
                        cv.fillStyle = ($scope.AccStatus[index] & 1) == 0 ? "green" : "orange";  // repos, actif
                        cv.fill();
                    }
                    cv.fillStyle = 'black';
                    cv.fillText((index + $scope.AccOffset + 1), xx + 5, yy + 20);
                    // cv.fillText($scope.AccStatus[index], xx + 5, yy + 70);
                }
            }
        }
    }

    $scope.swap8_16 = function() {
        $scope.AccPanelWidth = ($scope.AccPanelWidth == 16) ? 8 : 16;
        $scope.drawAccPanel();
    }

    $scope.accOffset = function() {
        $scope.AccOffset = ($scope.AccOffset == 0) ? 512 : 0;
        $scope.drawAccPanel();
    }

    $scope.AcclastPage = ( 512 / (4 * $scope.AccPanelWidth) ) - 1;

/*
    $scope.onClickAccPage = function(inPageCmd) {
        if( inPageCmd == 1 )
            $scope.AccPageNo = ($scope.AccPageNo < S88lastPage) ? ++$scope.AccPageNo : $scope.AcclastPage;
        else
            $scope.AccPageNo = ($scope.AccPageNo > 0) ? --$scope.AccPageNo : 0;

        $scope.drawAccPanel();
    }
*/
    $scope.onClickAccPage = function(inPageCmd) {
        console.log("inPageCmd: " + inPageCmd);
        if (inPageCmd == 1) {
            $scope.AccPageNo++;
        }
        else {
            $scope.AccPageNo--;
        }

        if ($scope.AccPageNo < 0) {
            $scope.AccPageNo = 0;
        }

        if ($scope.AccPageNo > $scope.AcclastPage) {
            $scope.AccPageNo = $scope.AcclastPage;
        }

        $scope.drawAccPanel();
    }

    $scope.onClickAccCanvas = function (e) {
        console.log("onClickAccCanvas: " + e);
        e.preventDefault();

        var rect = e.target.getBoundingClientRect();
        var x = e.clientX - rect.left;
        var y = e.clientY - rect.top;

        if(e.type == "touchstart") {
            x = e.touches[0].pageX - rect.left
            y = e.touches[0].pageY - rect.top
        }

        if (x > (8*112)) {
            if ($scope.AccPanelWidth == 16) {
                x -= 40;
            }
            else return;
        }

        var xx = Math.floor(x / 112);
        var yy = Math.floor(y / 100);
        var index = ($scope.AccPageNo * 4 + yy) * $scope.AccPanelWidth + xx;
        let value = $scope.AccStatus[index];

        if ('object' === typeof e) {
            let btnCode = e.button;

            switch (btnCode) {
                case 0:
                    if (value & 1 == 1) {
                        value &= 2;
                    }
                    else {
                        value |= 1;
                    }
                    // alert('Left button clicked. ' + index + '  ' + value);

                    $scope.ChangeAcc(index, value);
                    break;
                case 1:
                    // alert('Middle button clicked.');
                break;
                case 2:
                    value = (value + 2) % 4;
                    // alert('Right button clicked. ' + index + '  ' + value);
                break;
                default:
                    alert('Unexpected code: ' + btnCode);
            }
        }

        $scope.AccStatus[index] = value;
        $scope.drawAccPanel();
    }

    $scope.ChangeAcc = function(inNo, value) {
        let aAccAddr = inNo + $scope.AccOffset + 1;
        let address_acc = ((aAccAddr >> 2) & 0x1FF);       // 0..511
        let sub_address_acc = aAccAddr % 4;                // 0..3
        let cmd = "a " + address_acc + " " + sub_address_acc + " " + (value & 1);
        $scope.setParamDCC(cmd);
    }

    $scope.isTouch = ('ontouchstart' in window);

    $('#accCanvas').bind({
        'touchstart mousedown': function (e) {
            e.preventDefault();
            this.pageX = ($scope.isTouch ? event.changedTouches[0].pageX : e.pageX);
            this.pageY = ($scope.isTouch ? event.changedTouches[0].pageY : e.pageY);
        //  alert(this.pageX + "," + this.pageY);
        },
        'touchmove mousemove': function (e) {
            e.preventDefault();
        },
        'touchend mouseup': function (e) {
            e.preventDefault();
        }
    });

    $scope.sendXAdresseVal = function(xAd, xAd_Value) {
        let cmd = "a " + xAd + " " + xAd_Value;
        console.log("Cmd X : %s", cmd);
        $scope.setParamDCC(cmd);
    }


    //*******************************************************************************************//
    //****************************** Retro-signalisation S88 ************************************//
    //*******************************************************************************************//


    $scope.S88PageNo = 0;                  // S88
    $scope.binary = 0;                     // S88
    $scope.hexa = 1;                       // S88
    $scope.purehexa = 2;                   // S88
    $scope.s88MaxByte = 64;                // S88, les entrées sont comptées par groupe de 8 donc 64 * 8 = 512 capteurs
    $scope.s88Byte = 64;                   // S88
    $scope.format_S88 = 0;                 // S88, toggle bin/ASCII/hexa
    $scope.S88PanelWidth = 32;             // S88, toggle 32/16 columns
    $scope.S88Status = new Array(512, 0);  // S88
    const canvas = document.getElementById("s88Canvas");
    const cv = canvas.getContext("2d");

    $scope.setS88Byte = function() {
        $scope.s88Byte = parseInt(document.getElementById("s88Byte").value);
    }

    $scope.toggle_bit_hexa = function() {
        $scope.format_S88 = ($scope.format_S88 + 1) % 2;
        document.getElementById("btnS88Mode").innerHTML = "<b>" + ( ($scope.format_S88 == 0) ? "S88 b" : "S88 h" ) + "</b>";
        document.getElementById("format_S88").value = $scope.format_S88;
    }

    $scope.swap16_32 = function() {

        // Dessin du carré
        var cvSizeH = canvas.getAttribute("width");
        var cvSizeV = canvas.getAttribute("height");
        cv.clearRect(0, 0, cvSizeH, cvSizeV);

        canvas.setAttribute("style", "width: (cvSizeH > 1000) ? 900 : 1800) ");

        $scope.S88PanelWidth = ($scope.S88PanelWidth == 32) ? 16 : 32;

        $scope.drawS88Panel();
    }

    $scope.drawS88Panel = function() {
        // Dessin du carré
        var cvSizeH = document.getElementById("s88Canvas").getAttribute("width");
        var cvSizeV = document.getElementById("s88Canvas").getAttribute("height");
        cv.clearRect(0, 0, cvSizeH, cvSizeV);
        // Canvas - Choix de police
        cv.font = "16px 'arial'";
        $scope.checks88Byte();

        // Affichage des rectangles
        for (var y = 0; y < 4; y++) {
            for (var x = 0; x < $scope.S88PanelWidth; x++) {
                var xx = x * 55.5 + 16;
                if (x > 15) xx += 25;
                var yy = y * 100 + 1;
                var index = (y + $scope.S88PageNo * 4) * $scope.S88PanelWidth + x;

                cv.shadowBlur = 0;
                cv.fillStyle = '#EFEFEF';
                cv.strokeStyle = '#8F8F8F';
                cv.beginPath();
                cv.moveTo(xx, yy);
                cv.lineTo(xx + 50, yy);
                cv.lineTo(xx + 50, yy + 80);
                cv.lineTo(xx, yy + 80);
                cv.lineWidth = "1px";
                cv.lineCap = "round";
                cv.closePath();
                cv.fill();
                cv.stroke();

                // Spécification de dégradé
                cv.shadowColor = '#9F9F9F';
                cv.shadowOffsetX = 0;
                cv.shadowOffsetY = 0;
                cv.shadowBlur = 8;

                // Affichage des points ronds
                if ($scope.S88Status[index] == 0) {        // libre
                    cv.beginPath();
                    cv.arc(xx + 25, yy + 50, 16, 0, Math.PI * 2, false);
                    cv.fillStyle = ( index < ($scope.s88Byte*4) ? "green" : "lightgreen" );
                    cv.fill();
                }
                else if ($scope.S88Status[index] == 1) {   // occupé
                    cv.beginPath();
                    cv.arc(xx + 25, yy + 50, 16, 0, Math.PI * 2, false);
                    cv.fillStyle = "red";
                    cv.fill();
                    }
                    else {                                 // indéfini
                        cv.beginPath();
                        cv.arc(xx + 25, yy + 50, 16, 0, Math.PI * 2, false);
                        cv.fillStyle = "grey";
                        cv.fill();
                    }

                cv.fillStyle = "#A52A2A";
                cv.fillText(index + 1, xx + 15, yy + 20);
            }
        }
    }

    $scope.S88lastPage = ( 512 / (4 * $scope.S88PanelWidth) ) - 1;
/*
    $scope.onClickS88Page = function(inPageCmd) {
        if( inPageCmd == 1 )
            $scope.S88PageNo = ($scope.S88PageNo < S88lastPage) ? ++$scope.S88PageNo : $scope.S88lastPage;
        else
            $scope.S88PageNo = ($scope.S88PageNo > 0) ? --$scope.S88PageNo : 0;

        $scope.drawS88Panel();
    }
*/
    $scope.onClickS88Page = function(inPageCmd) {
        if (inPageCmd == 1) {
            $scope.S88PageNo++;
        }
        else {
            $scope.S88PageNo--;
        }

        if ($scope.S88PageNo < 0) {
            $scope.S88PageNo = 0;
        }
        else if ($scope.S88PageNo > $scope.S88lastPage) {
                vS88PageNo = $scope.S88lastPage;
            }

        $scope.drawS88Panel();
    }

    $scope.checks88Byte = function() {
        let tempS88B = parseInt(document.getElementById("s88Byte").value);

        if (tempS88B > $scope.s88MaxByte)
            tempS88B = $scope.s88MaxByte;
        else if (tempS88B < 0)
            tempS88B = 0;

        $scope.s88Byte = tempS88B;
        document.getElementById("s88Byte").value = $scope.s88Byte.toString(10);
        document.getElementById("format_S88").value = $scope.format_S88;
    }

    S88_Enter = function () {
        if (event.keyCode == 13) {
            $scope.setS88Byte();
            $scope.read_S88();
        }
    }

    $scope.read_S88 = function() {                         // lire le bus S88, 64 modules de 8 capteurs maxi
        let cmd = "";
        let s88_Byte = document.getElementById("s88Byte").value;
        let formatS88 = document.getElementById("format_S88").value;

        cmd = "Y " + s88_Byte + " " + formatS88;           // 0 binaire, 1 hexadecimal
        $scope.setParamDCC(cmd);
        console.log("Cmd Y : %s", cmd);
    }


    //*******************************************************************************************//
    //****************************** Requêtes http et websockets ********************************//
    //*******************************************************************************************//


    // Affichage de la réponse pour les requettes http
    $scope.afficheReponse = function (response) {
        var response = response.replace("<", "").replace(">", "");
        monitor.innerHTML += "DCCpp : " + response + "<br />"; // add incoming message from server to the log screen previous string + new string(message)
        $scope.scroll();
        $scope.responseServer = response;                                                      // envoie la reponse dans Log

        if(null != $scope.param) {
            $timeout($scope.clearAfficheResponse, $scope.param.responseDislayTimeout);         // ... pendant x secondes
        } else {
            $timeout($scope.clearAfficheResponse, 5000);
        }
    }

    // Affichage de la réponse pour les requettes WS
    $scope.afficheReponseServ = function (response) {
        var response = response.data;
        var response2monitor = response.replace("<", "").replace(">", "");
        if (monitor.innerHTML.length > 100000) monitor.innerHTML = "";

//        if (response.startsWith("<")) {
        if (response.charAt(0) == '<') {
            monitor.innerHTML += "DCCppS88 : " + response2monitor + "<br />";  // add incoming message from server to the log screen previous string + new string(message)
        } else {
            monitor.innerHTML += "ESP &nbsp; &nbsp &nbsp; : " + response + "<br />";  // add incoming message from server to the log screen previous string + new string(message)
        }
        $scope.scroll();

        if ( (response.indexOf("<r123|123|") == 0) || (response.indexOf("<r456|456|") == 0) )
            $scope.parseCv(response);
        else
            $scope.parseMsg(response);

        if (response.startsWith("<y") == false ) {
                $scope.responseServer = response;                         // envoie la reponse dans Log
        }

        if(null != $scope.param) {
            $timeout($scope.clearAfficheResponse, $scope.param.responseDislayTimeout);         // ... pendant x secondes
        } else {
            $timeout($scope.clearAfficheResponse, 5000);
        }
    }

    $scope.parseMsg = function (response) {
        console.log(response);
        if (response.startsWith("<p")) {                                  // Power
            monitor.innerHTML += "DCC Power switched : ";
            // monitor.innerHTML += (response == "<p1>") ? "On" : "Off";
            var inPowerStr = response.replace('<p', '').replace('>', '');
            var inPower = parseInt(inPowerStr);
            var signal = document.getElementById('signal');

            switch (inPower) {
                case 0:
                    $scope.stopLoco();
                    $scope.powerStatus = false;
                    signal.style.visibility = "hidden";
                    signal.width = '120';
                    signal.height = '120';
                    signal.src = './img/CarreMecanique.png';
                    signal.setAttribute('title', 'Arrêt absolu');
                    signalText.innerHTML = 'DCC stoppé !';
                    signal.style.visibility = "visible";
                    mainBar.className = mainBar.className.replace('w3-teal', 'w3-red');
                    monitor.innerHTML += "Off ==&gt; Réseau DCC hors tension";
                    break;
                case 1:
                    $scope.powerStatus = true;
                    monitor.innerHTML += "On ==&gt; Réseau DCC sous tension";
                    signal.style.visibility = "hidden";
                    signal.width = '84';
                    signal.height = '178';
                    signal.src = './img/VoieLibre.png';
                    signal.setAttribute('title', 'Coupez courant');
                    signalText.innerHTML = 'Voie libre !';
                    signal.style.visibility = "visible";
                    mainBar.className = mainBar.className.replace('w3-red', 'w3-teal');
                    break;
                case 2:
                    $scope.stopLoco();
                    $scope.powerStatus = false;
                    signal.style.visibility = "hidden";
                    signal.width = '120';
                    signal.height = '120';
                    signal.src = './img/CarreMecanique.png';
                    signal.setAttribute('title', 'Arrêt absolu');
                    signalText.innerHTML = 'DCC stoppé !';
                    signal.style.visibility = "visible";
                    response += '     Surcharge en courant !';
                    mainBar.className = mainBar.className.replace('w3-teal', 'w3-red');
                    monitor.innerHTML += 'Off ==&gt; Surcharge en courant sur les voies principales';
                    alert('Surcharge en courant sur voies principales');
                    break;
                case 3:
                    break;
                case 4:
                    $scope.powerStatus = false;
                    signal.style.visibility = "hidden";
                    signal.width = '120';
                    signal.height = '120';
                    signal.src = './img/CarreMecanique.png';
                    signal.setAttribute('title', 'Arrêt absolu');
                    signalText.innerHTML = 'DCC stoppé !';
                    signal.style.visibility = "visible";
                    mainBar.className = mainBar.className.replace('w3-teal', 'w3-red');
                    monitor.innerHTML += 'Off ==&gt; Surcharge en courant sur la voie de programmation';
                    alert('Surcharge en courant sur voie de programmation');
                    break;
                case 5:
                    break;
                case 6:
                    $scope.stopLoco();
                    $scope.powerStatus = false;
                    signal.style.visibility = "hidden";
                    signal.width = '120';
                    signal.height = '120';
                    signal.src = './img/CarreMecanique.png';
                    signal.setAttribute('title', 'Arrêt absolu');
                    signalText.innerHTML = 'DCC stoppé !';
                    signal.style.visibility = "visible";
                    mainBar.className = mainBar.className.replace('w3-teal', 'w3-red');
                    monitor.innerHTML += 'Off ==&gt; Surcharge en courant sur les voies principales externes';
                    alert('Surcharge en courant sur voies principales externes');
                    break;
            }
            monitor.innerHTML += "<br />";
            $scope.scroll();
        } else if (response.startsWith("<T")) {                             // Throttle
           let temp = response.replace("<T", "").replace(">", "");
           let spaceIndex = temp.indexOf(" ");
           let locoID = parseInt(temp.substring(0, spaceIndex), 10);
           temp = temp.substring(spaceIndex+1);
           spaceIndex = temp.indexOf(" ");
           let locoAddress = parseInt(temp.substring(0, spaceIndex), 10);
           temp = temp.substring(spaceIndex+1);
           spaceIndex = temp.indexOf(" ");
           let locoSpeed = parseInt(temp.substring(0, spaceIndex), 10);
           let locoDir = parseInt(temp.substring(temp.lastIndexOf(" ")), 10);
           // monitor.innerHTML += ("temp0 " + temp + " locoID " + locoID + " locoAddress " + locoAddress + " locoSpeed " + locoSpeed + " locoDir " + locoDir) + "<br />";
           // console.log("temp " + temp + " locoID " + locoID + " locoAddress " + locoAddress + " locoSpeed " + locoSpeed + " locoDir " + locoDir);
           if ($scope.locomotives[--locoID].address == locoAddress) {         // feedback any loco move
               $scope.locomotives[locoID].sens = locoDir;
               $scope.locomotives[locoID].vitesse = locoSpeed;
               if ($scope.locoSelectionnee.address == locoAddress) {
                   $scope.gaugeBusy = true;
                   document.gauges.get('throttleSpeedGauge').value = locoSpeed * $scope.maxSpeed / $scope.maxStep;
                   $scope.gaugeBusy = false;
///                   $("#speedSlider").slider("value", locoSpeed);               // generates issues
               }
           }
        } else if (response.startsWith("<F")) {                           // Functions
            let temp = response.replace("<F0 ","").replace(">", "");
            let spaceIndex = temp.indexOf(" ");
            let locoAddress = parseInt (temp.substring(0, spaceIndex), 10);
            temp = temp.substring(spaceIndex+1);
            spaceIndex = temp.indexOf(" ");
            let locoFunction1 =  parseInt (temp.substring(0, spaceIndex), 10);
            let state = false;
            // console.log("temp " + temp + "   locoAddress " + locoAddress + "   locoFunction " + locoFunction1);
            if (locoFunction1 >= 222) {
                temp = temp.substring(spaceIndex+1);
                let locoFunction2 = parseInt (temp.substring(0), 10);
                let locoFunction = locoFunction2;
                let start = 13;
                if (locoFunction1 == 223) start +=8;
                let end = start + 8;
                // setFunctBtn(locoAddress, locoFunction, start, end);
                for (let i = start ; i < end ; i++) {
                    let j = i.toString();
                    //console.log(i + "   locoFunction2 " + locoFunction2 + "   " + 'Fn' + j + "   " + locoAddress);
                    state = ((locoFunction2 & 1) == 1) ? true : false;
                    document.getElementById('Fn' + j).checked = state;
                    if ($scope.locoSelectionnee.address == locoAddress) document.getElementById('Fn' + j).click;
                    locoFunction2 >>= 1;
                }
            } else if (locoFunction1 >= 176) {
                let locoFunction = locoFunction1;
                let start = 5;
                let end = 9;
                for (let i = start ; i < end ; i++) {
                    let j = i.toString();
                    //console.log(i + "   locoFunction1 " + locoFunction1 + "   " + 'Fn' + j + "   " + locoAddress);
                    state = ((locoFunction1 & 1) == 1)  ? true : false;
                    document.getElementById('Fn' + j).checked = state;

                    // if (locoFunction1 & 1) {
                    // document.getElementById('Fn' + j).checked = true;
                    // }
                    // else document.getElementById('Fn' + j).checked = false;

                    if ($scope.locoSelectionnee.address == locoAddress) document.getElementById('Fn' + j).click;
                    locoFunction1 >>= 1;
                }
            } else if (locoFunction1 >= 160) {
                for (let i = 9 ; i < 13 ; i++) {
                    let j = i.toString();
                    if (locoFunction1 & 1) {
                        //console.log(i + "   locoFunction1 " + locoFunction1 + "   " + 'Fn' + j + "   " + locoAddress);
                        document.getElementById('Fn' + j).checked = true;
                    }
                    else document.getElementById('Fn' + j).checked = false;

                    if ($scope.locoSelectionnee.address == locoAddress) document.getElementById('Fn' + j).click;
                    locoFunction1 >>= 1;
                }
            } else if (locoFunction1 >= 128) {
                for (let i = 1 ; i < 6 ; i++) {
                    let j = (i%5).toString();
                    if (locoFunction1 & 1) {
                        //console.log(i + "   locoFunction1 " + locoFunction1 + "   " + 'Fn' + j + "   " + locoAddress);
                        document.getElementById('Fn' + j).checked = true;
                    }
                    else document.getElementById('Fn' + j).checked = false;

                    if ($scope.locoSelectionnee.address == locoAddress) document.getElementById('Fn' + j).click;
                    locoFunction1 >>= 1;
                }
            } else return;
        } else if (response.startsWith("<H")) {       // commutation d'aiguillage par une action externe
            monitor.innerHTML += "Turnout update" + "<br />";
            console.log("Turnout update");
            var chain = response.replace("<H", "").replace(">", "");
            while (chain.startsWith(" ")) chain = chain.substr(1,);
            var p = chain.indexOf(" ");
            var chainAdr = chain.substr(0, p);
            var turnoutAdr = parseInt(chainAdr);
            console.log("p : " + p + "   chainAdr : " + chainAdr + "   turnoutAdr : " + turnoutAdr);
            if ((turnoutAdr < 1) || (turnoutAdr > 2047)) return;
            chain = chain.substr(p+1,);
            var dir = parseInt(chain);
            if ((dir < 0) || (dir > 1))return;

            $scope.AccStatus[turnoutAdr-1] = dir;
            $scope.drawAccPanel();
        } else if (response.startsWith("<A")) {       // commutation d'aiguillage par une action externe
            monitor.innerHTML += "Accessory update" + "<br />";
            console.log("Accessory update");
            var chain = response.replace("<A", "").replace(">", "");
            while (chain.startsWith(" ")) chain = chain.substr(1,);
            var p = chain.indexOf(" ");
            var pp = chain.indexOf("/");
            var chainAdr = 4*chain.substr(0, p);
            var turnoutAdr = parseInt(chainAdr) + parseInt(chain.substr(pp+2, pp+3));
            console.log("p : " + p + "   chainAdr : " + chainAdr + "   turnoutAdr : " + turnoutAdr);
            if ((turnoutAdr < 1) || (turnoutAdr > 2047)) return;
            chain = chain.substr(pp+5,);
            var dir = parseInt(chain);
            if ((dir < 0) || (dir > 1))return;

            $scope.AccStatus[turnoutAdr-1] = dir;
            $scope.drawAccPanel();
        } else if (response.startsWith("Bienvenue") || response.startsWith("Welcome")) {  // lecture et affichage du n° client
            var str = response;
            var nClient = response.charAt(str.length-1);
            // console.log("nClient : ", nClient);
            document.getElementById("Nclient").innerHTML = nClient;
        } else if (response.startsWith("<a")) {       // courant Main et Main2
            if (isConnected && $scope.powerStatus) {
                let current = response.split("a")[1].replace(">", "");
                let c_temp = parseInt(current, 10);
                c_temp = (c_temp < 3 ? 0 : 10*c_temp + 65); // valeur approchée en mA
                c_temp = Math.round(c_temp);
                current = c_temp.toString() + " mA" ;
                console.log("courant Main = " + current);
                monitor.innerHTML += ("Voies principales, courant = " + c_temp + " mA<br />");
                document.getElementById('displayCurrent').value = c_temp.toString() + " mA";
                document.getElementById('displayCurrent').style.background = "#eee";
                current = response.split(" ")[1].replace(">", "");
                c_temp = parseInt(current, 10);
                c_temp = (c_temp < 3 ? 0 : 9.4 * c_temp + 65); // valeur approchée en mA
                c_temp = Math.round(c_temp);
                current = c_temp.toString() + " mA" ;
                console.log("courant ext. = " + current);
                monitor.innerHTML += ("Voies externes, courant = " + c_temp + " mA<br />");
                document.getElementById('displayCurrent2').value = c_temp.toString() + " mA";
                document.getElementById('displayCurrent2').style.background = "#eee";
                setTimeout (function () {
                    document.getElementById('displayCurrent').style.background = "#999";
                    document.getElementById('displayCurrent2').style.background = "#999";
                }, 5000);
                // setTimeout (function () {
                    // document.getElementById('displayCurrent').style.background = "#999";
                // }, 5000);
            } else {
                document.getElementById('displayCurrent').style.background = "#999";
                document.getElementById('displayCurrent').value = "0 mA";
                document.getElementById('displayCurrent2').style.background = "#999";
                document.getElementById('displayCurrent2').value = "0 mA";
            }
        } else if (response.startsWith("<z")) {       // courant ************************************* réponse supprimée dans DCCppS88
            if (isConnected && $scope.powerStatus) {
                let current = response.split("z")[1].replace(">", "");
                let c_temp = parseInt(current, 10);
                c_temp = (c_temp < 3 ? 0 : 10*c_temp + 65); // valeur approchée en mA
                c_temp = Math.round(c_temp);
                monitor.innerHTML += ("Voies externes, courant = " + c_temp + " mA<br />");
                document.getElementById('displayCurrent2').value = c_temp.toString() + " mA";
                document.getElementById('displayCurrent2').style.background = "#eee";
                setTimeout (function () {
                    document.getElementById('displayCurrent2').style.background = "#999";
                }, 5000);
            } else {
                document.getElementById('displayCurrent2').style.background = "#999";
                document.getElementById('displayCurrent2').value = "0 mA";
            }
        } else if (response.startsWith("<y")) {       // S88
            var s88chain = response.replace("<y", "").replace("> ", "");
            let i = 0;
            var sensor = 0;
            $scope.checks88Byte();

            switch($scope.format_S88) {
            case $scope.binary:
                for (i = 0; i < (8*$scope.s88Byte); i++) {
                    let sub_s88chain = s88chain.substr((i + 1), 1);
                    $scope.S88Status[i] = parseInt(sub_s88chain, 2);
                }
                for (i = i; i < (8*$scope.s88MaxByte); i++) {
                    $scope.S88Status[i] = 2;
                }
                break;
            case $scope.hexa:
                for (i = 0; i < (2*$scope.s88Byte); i++) {
                    let sub_s88chain = s88chain.substr((i + 1), 1);
                    sensor = parseInt(sub_s88chain, 16);
                    $scope.S88Status[4*i]   = (sensor & 0x08) == 0 ? 0 : 1;
                    $scope.S88Status[4*i+1] = (sensor & 0x04) == 0 ? 0 : 1;
                    $scope.S88Status[4*i+2] = (sensor & 0x02) == 0 ? 0 : 1;
                    $scope.S88Status[4*i+3] = (sensor & 0x01) == 0 ? 0 : 1;
                }
                for (i = 4*i; i < (8*$scope.s88MaxByte); i++) {
                    $scope.S88Status[i] = 2;
                }
                break;
            default:
                break;
            }  // end of switch

            $scope.drawS88Panel();
        } else if (response.startsWith("RSSI")) {                         // RSSI
            document.getElementById('RSSI').value = response.substring(5, 8);
        }
    }

    $scope.clearAfficheResponse = function () {
        // $scope.responseServer = "";
    }

    $scope.scroll = function () {
        monitor.scrollTop = monitor.scrollHeight;
    }

    //************************************** Requette http **************************************//

    $scope.httpReq = function(method, url, data) {
        return $q(function(resolve, reject) {
            $http({
                method: method,
                url: url,
                data: data,
                headers: {
                    'Content-Type': 'text/plain'
                }
            }).
            success(function(response) {
                $scope.afficheReponse(response);
                $scope.suitePgm = true;
                resolve(response);
            }).
            error(function(data, status, headers, config) {
                reject(data, status, headers, config)
                $scope.afficheReponse("error");
            });
        });
    }

    //************************************ Requette WebSocket ***********************************//

    const monitor=document.getElementById('monitor');

    // Modification de l'IP du serveur Node, deconnexion puis reconnexion avec la nouvelle adresse
    // $scope.newIpNodeJs = function () {
        // $scope.socket = io.disconnect();
        // $scope.socket = io.connect(param.ipWS);
    // }

    toggleCheck = function () {
        if (isConnected) {
            $scope.disconnect();
        } else {
            console.log("try to connect to : ws://" + ip + ':' + $scope.portWS);
            $scope.connect('ws://' + ip + ':' + $scope.portWS);
        }
    }

    $scope.connect = function (server) {
        // $scope.socket = new WebSocket('ws://'+location.hostname+':81/', ['arduino']);
        console.log('connecting', server);
        monitor.innerHTML += "\nConnecting to...\n" + server + "<br />";
        $scope.socket = new WebSocket(server, ['arduino']);

      $scope.disconnect = function () {
        monitor.innerHTML += "WiFi connexion closed<br />";
        document.getElementById("WiFiConnect").className ="btn btn-warning btn-md";
        document.getElementById("WiFiConnect").innerHTML ="Connecter";
        document.getElementById("WiFiLogo").style.visibility = "hidden";
        document.getElementById("Nclient").innerHTML = ' ';
        if ($scope.socket != null) {
            $scope.socket.close(1000, "Closing WiFi Connection");
        }
      };

      //  Affiche la réponse si connexion
      $scope.socket.onopen = function (e) {
        isConnected = true;
        monitor.innerHTML += "WiFi connexion successfull<br />";
        $scope.scroll();
        console.log('WiFi DCC WebSocket client connected ...');
        document.getElementById("WiFiLogo").style.visibility = "visible";
        document.getElementById("WiFiConnect").className  ="btn btn-success btn-md";
        document.getElementById("WiFiConnect").innerHTML ="Déconnecter";
        IPWS.value = ip;
        setTimeout(function () {
            $scope.setParamDCC('s');
        }, 5000);
      };

      // Lorsque la connexion se termine.
      $scope.socket.onclose = function (e) {
        isConnected = false;
        $scope.socket = null;
        document.getElementById("WiFiLogo").style.visibility = "hidden";
        // document.getElementById('WiFiConnect').checked = false;
        powerStatus = false;
        // if ($scope.powerStatus === true) $scope.powerStatus = false;
        mainBar.className = mainBar.className.replace('w3-teal', 'w3-red');
        document.getElementById("WiFiConnect").className  ="btn btn-warning btn-md";
        document.getElementById("WiFiConnect").innerHTML ="Connecter";
        document.getElementById("Nclient").innerHTML = ' ';
        monitor.innerHTML += "\nConnexion terminée<br />";
        console.log("Disconnected");
        $scope.responseServer = "WiFi déconnecté";
      };

      // Listen for connection errors
      $scope.socket.onerror = function (e) {
        console.log("WS Error " + e);
      };

      // Envoi de requette vers le MEGA
      $scope.sendReq = function (data) {
        $scope.socket.send(data);                                              // send to DCC
      };

      //  Ecouteur pour la réponse du MEGA
      $scope.socket.onmessage = function (response) {
        $scope.afficheReponseServ(response);
      };

    }


    //*******************************************************************************************//
    //************************* Mise sous tension ou coupure du réseau **************************//
    //*******************************************************************************************//

    // Methode pour mettre le réseau sous tension...
    $scope.power = function() {
        var data = $scope.powerStatus ? 0 : 1;
        $scope.powerStatus = data;
        if (data == 1) {
//            $scope.setUpLocos();       // puis toutes les locos sont mises à l'arret.
            $scope.sendReq("<t1 0 0 1>");  // arret de toutes les locos.
        }

        $scope.setParamDCC(data);      // Power toggle sent to DCC
    }

    $scope.setUpLocos = function () {
        // On met toutes les locos à l'arrêt
        for(var i = 0; i < $scope.locomotives.length; i++) {
            if ($scope.locomotives[i].address > 3) {
                $scope.locomotives[i].vitesse = -1;
                $scope.locomotives[i].sens = 1;
                var data = "t ";
                data += $scope.locomotives[i].id;
                data += " ";
                data += $scope.locomotives[i].address;
                data += " ";
                data += $scope.locomotives[i].vitesse;
                data += " ";
                data += $scope.locomotives[i].sens;
                data = "<" + data + ">";
                $scope.sendReq(data);
            }
        }
    }


    //*******************************************************************************************//
    //********************************** Chargement des données *********************************//
    //*******************************************************************************************//

    //************ Chargement du fichier des locomotives à partir du menu paramètres ************//

    $scope.loadLocos = function () {
        ///display.scrollTop = display.scrollHeight;

        if (window.location.hostname != '') {
            // Url du serveur intégré dans la centrale DCC en WiFi

            console.log("loading locos.json from Flash/SDcard");
            $scope.loadLocosF();
            monitor.innerHTML += "\nFichier des locos chargé depuis la Flash/SDcard" + "<BR />";
            console.log($scope.locomotives);
        }

        else {
           console.log("reading locos.json from Files server");
           $scope.readTextFile(urlFlash+$scope.tab_pathConfigFiles[0], function(text) {     //  from PC read locos.json stored in Flash/SDcard
               $scope.locomotives = JSON.parse(text);
               monitor.innerHTML += "\nFichier des locos chargé depuis le serveur" + "<BR />";
               console.log($scope.locomotives);
           });
        }

        setTimeout( function () {
            $scope.initLoco();
        }, 3000);        // time to read into Flash/SDcard
    }

    //********************************** Depuis le localstorage *********************************//

    $scope.loadLocalStorage = function () {
		try {
			$scope.locomotives = JSON.parse(localStorage.getItem("locomotives"));
			$scope.param = JSON.parse(localStorage.getItem("param"));
			$scope.manufacturers = JSON.parse(localStorage.getItem("manufacturers"));
			$scope.cvLabels = JSON.parse(localStorage.getItem("cvLabels"));
			$scope.localStorageLength = localStorage.length;
		} catch (err) {
			console.log("Files not found in localStorage");
		}
		
        if (localStorage.length > 0){
            console.log("Successfull import files from LocalStorage"); //". Length = " + localStorageLength);
            monitor.innerHTML += "Fichier des locos chargé depuis le LocalStorage" + "<BR />";
        }
        else
            console.log("No file in localStorage");
    }

    $scope.recLocalstorage = function() {
		try {
        localStorage.setItem("locomotives",JSON.stringify($scope.locomotives));
        localStorage.setItem("param",JSON.stringify($scope.param));
        localStorage.setItem("manufacturers",JSON.stringify($scope.manufacturers));
        localStorage.setItem("cvLabels",JSON.stringify($scope.cvLabels));
        $scope.localStorageLength = localStorage.length;
		} catch (err) {
			console.log("Files not found in localStorage");
		}
    }

    $scope.removeLocalstorage = function() {
        localStorage.removeItem("locomotives");
        localStorage.removeItem("param");
        localStorage.removeItem("manufacturers",JSON.stringify($scope.manufacturers));
        localStorage.removeItem("cvLabels",JSON.stringify($scope.cvLabels));
        $scope.localStorageLength = localStorage.length;
    }

    //******************* Sauvegarde automatique quand on quitte l'application ******************//

    window.onbeforeunload = function (e) {
        console.log("End of session.");
        // on enregistre aussi toutes les données dans le "localStorage" du navigateur avant de quitter
        if($scope.param.localStorageActive)
            $scope.recLocalstorage();
        // ... et sur le disque.
        // $scope.saveHD();
        $scope.hdSave();
    }

    //********************************** ou à partir de la Flash/SDcard *************************//

    // Chargement de l'objet "locomotives" (qui contient toutes les infos sur les locos) à partir de la Flash/SDcard
    $scope.loadLocosF = function () {
        return $q(function(resolve, reject) {
            $http({
                    method: 'GET',
                    url: urlFlash+$scope.tab_pathConfigFiles[0]
                })
                .success(function(response) {
                    $scope.locomotives = response;
                    resolve(response);
                    $scope.afficheReponse("\nFichier des locos de la Flash/SDcard chargé : " + $scope.tab_pathConfigFiles[0]);
                })
                .error(function(data, status, headers, config) {
                    reject(data, status, headers, config);
            });
        });
    }

    // Chargement du fichier des constructeurs de décodeurs à partir de la Flash/SDcard
    $scope.loadManufacturersF = function () {
        return $q(function(resolve, reject) {
            $http({
                    method: 'GET',
                    url: urlFlash+$scope.tab_pathConfigFiles[1]
                })
                .success(function(response) {
                    $scope.manufacturers = response;
                    resolve(response);
                    $scope.afficheReponse("\nFichier des constructeurs de la Flash/SDcard chargé : " + $scope.tab_pathConfigFiles[1]);
                })
                .error(function(data, status, headers, config) {
                    reject(data, status, headers, config);
                    console.log(data);
            });
        });
    }

    // Chargement du fichier des labels pour les CV's de décodeurs à partir de la Flash/SDcard
    $scope.loadCvLabelsF = function () {
        return $q(function(resolve, reject) {
            $http({
                    method: 'GET',
                    url: urlFlash+$scope.tab_pathConfigFiles[2]
                })
                .success(function(response) {
                    $scope.cvLabels = response;
                    resolve(response);
                    $scope.afficheReponse("\nFichier des labels de CV's de la Flash/SDcard chargé : " + $scope.tab_pathConfigFiles[2]);
                })
                .error(function(data, status, headers, config) {
                    reject(data, status, headers, config);
                    console.log(data);
            });
        });
    }

    // Chargement du fichier des parametres à partir de la Flash/SDcard
    $scope.loadParamF = function () {
        return $q(function(resolve, reject) {
            $http({
                    method: 'GET',
                    url: urlFlash+$scope.tab_pathConfigFiles[3]
                })
                .success(function(response) {
                    $scope.param = response;
                    resolve(response);
                    $scope.afficheReponse("\nFichier des paramètres de la Flash/SDcard chargé : " + $scope.tab_pathConfigFiles[3]);
                })
                .error(function(data, status, headers, config) {
                    reject(data, status, headers, config);
                    console.log(data);
            });
        });
    }

    //********************************** ou à partir du serveur *********************************//

     $scope.readTextFile = function (file, callback) {
        if (confirm("Vous allez effacer les données actuelles de vos locomotives, voulez-vous poursuivre ?")) {
            var rawFile = new XMLHttpRequest();
            rawFile.overrideMimeType("application/json");
            var p = ip.indexOf(":");
            var ips = ip.substring(0, p);
            file = "http://" + ips + "/" + file;        // strip port
            rawFile.onreadystatechange = function() {
                if (rawFile.readyState === 4 && rawFile.status == "200") {
                    //// callback(rawFile.responseText);
                    callback(rawFile.response);
                }
            }
            rawFile.open("GET", file, true);
            rawFile.send();
        }
    }


    //*******************************************************************************************//
    //****************************** Sauvegarde des données *************************************//
    //*******************************************************************************************//


    $scope.hdSave = function () {
        for(let i = 0; i < $scope.tab_pathConfigFiles.length; i++) {
            let path = $scope.tab_pathConfigFiles[i];

            switch (i) {
                case 0:
                    data = JSON.stringify($scope.locomotives);
                    break;
                case 1:
                    data = JSON.stringify($scope.manufacturers);
                    break;
                case 2:
                    data = JSON.stringify($scope.cvLabels);
                    break;
                case 3:
                    data = JSON.stringify($scope.param);
                    break;
            }
            // $scope.socket.send('saveHD', data, path);
            console.log('saveHD  ' + data + '  ' + path);
        }
    }


    //*******************************************************************************************//
    //********** Sauvegarde de locos.json dans la zone de téléchargement du navigateur **********//
    //*******************************************************************************************//

    // Mathieu addon
    $scope.downloadConfig = function (globalConfig, data) {
        let filename;

        if (globalConfig) {
            filename = 'locos.json';
            data = $scope.locomotives;
        } else {
            filename = `${data.nomCourt}.json`;
        }

        const blob = new Blob([JSON.stringify(data, null, 0)], {type: 'application/json'});

        // If current navigator has Blob api, use it
        if (window.navigator.msSaveOrOpenBlob) {
            window.navigator.msSaveBlob(blob, filename);
        } else {
            // else use fake html element
            const elem = window.document.createElement('a');
            elem.href = window.URL.createObjectURL(blob);
            elem.download = filename;
            document.body.appendChild(elem);
            elem.click();
            document.body.removeChild(elem);
        }
    }


    //*******************************************************************************************//
    //******* Initialisation de certaines valeurs de l'objet "locomotives" au chargement ********//
    //*******************************************************************************************//


    $scope.initLoco = function() {
        for (var x in $scope.locomotives) {
            $scope.locomotives[x].vitesse = 0;
            $scope.locomotives[x].sens = 1;
            $scope.locomotives[x].id = Number(x)+1;
            $scope.createCv(x, 0, lastCv);                                          // modif 511
        }

        if (x > -1)
            $scope.keyOfLastId = $scope.locomotives[x].id;
    }


    //*******************************************************************************************//
    //********************************** Demarrage de l'appli ***********************************//
    //*******************************************************************************************//


    $scope.onLoadInit = function() {                       // Initialisation
        mainBar.className = mainBar.className.replace('w3-teal', 'w3-red');
        $scope.responseServer = "WiFi non connecté";

        for (let i = 0; i < 512; i++) {
            $scope.AccStatus[i] = 0;
            $scope.S88Status[i] = 2;
        }

        $scope.drawS88Panel();
        $scope.drawAccPanel();

        const canvasSpeedG = document.getElementById("throttleSpeedGauge");
        canvasSpeedG.addEventListener("mousedown", onClickCanvas);
        // canvasSpeedG.addEventListener("touchstart", onClickCanvas);
        toggleCheck();
    }

    $scope.startCtrl = function () {

        // Chargement des fichiers à partir du localStorage
        $scope.loadLocalStorage();

        // ... ou dans la Flash/SDcard s'il n'y a pas de données dans le local_storage 
        if (window.location.hostname != '') {
            // Url du serveur intégré dans la centrale DCC en WiFi

            if($scope.param == null) {
                monitor.innerHTML += "Fichier des locos chargé depuis la Flash/SDcard" + "<BR />";
                $scope.loadParamF();
                console.log("Loading json files from Flash/SDcard");
            }

            if($scope.locomotives == null)
                $scope.loadLocosF();

            if($scope.manufacturers == null)
                $scope.loadManufacturersF();

            if($scope.cvLabels == null)
                $scope.loadCvLabelsF();
        }
        else {    // ...ou sur le serveur (Flash/SDcard) si le local storage est vide
            if($scope.param == null) {
                $scope.readTextFile(urlFlash+$scope.tab_pathConfigFiles[3], function(text) {     // from PC read param.json stored in Flash/SDcard
                    $scope.param = JSON.parse(text);
                    console.log("Reading param.json from Flash/SDcard");
                });
            }

            if($scope.locomotives == null) {
                $scope.readTextFile(urlFlash+$scope.tab_pathConfigFiles[0], function(text) {     // from PC read locos.json stored in Flash/SDcard
                    $scope.locomotives = JSON.parse(text);
                    console.log("Reading locos.json from Flash/SDcard");
                });
            }

            if($scope.manufacturers == null) {
                $scope.readTextFile(urlFlash+$scope.tab_pathConfigFiles[1], function(text) {     // from PC read manufacturers.json stored in Flash/SDcard
                    $scope.manufacturers = JSON.parse(text);
                    console.log("Reading manufacturers.json from Flash/SDcard");
                });
            }

            if($scope.cvLabels == null) {
                $scope.readTextFile(urlFlash+$scope.tab_pathConfigFiles[1], function(text) {     // from PC read cvLabels.json stored in Flash/SDcard
                    $scope.cvLabels = JSON.parse(text);
                    console.log("Reading cvLabels.json from Flash/SDcard");
                });
            }
        }

        $scope.initLoco();
        $scope.onLoadInit();
    }

    $scope.startCtrl();
});
